#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <climits>
#include <string>

#define MAX 3 + 1
#define ll long long

using namespace std;

bool avail[MAX];

int main()
{
    int n, m;
    freopen("game.in", "r", stdin);
    freopen("game.out", "w", stdout);
    scanf("%d%d\n", &n, &m);
    for(int i = 0; i < MAX; i++){
        avail[i] = false;
    }
    char cur = '\0';
    int cur_cnt = 0;
    for(int i = 0; i < m; i++){
        char tmp;
        scanf("%c", &tmp);
        if(tmp == cur){
            cur_cnt++;
        }else{
            if(cur_cnt < MAX)
                avail[cur_cnt] = true;
            cur_cnt = 1;
            cur = tmp;
        }
    }
    if(cur_cnt < MAX)
        avail[cur_cnt] = true;
    if(avail[3]){
        int sum = n / 3;
        int rest = n % 3;
        if(rest == 0){
            printf("%d\n", sum);
        }else if((!avail[2]) && (!avail[1])){
            printf("-1\n");
        }else if(rest == 1 && avail[1]){
            printf("%d\n", sum + 1);
        }else if(rest == 1 && avail[2]){
            if(sum == 0)
                printf("-1\n");
            else
                printf("%d\n", sum + 1);
        }else if(rest == 2 && avail[2]){
            printf("%d\n", sum + 1);
        }else if(rest == 2 && avail[1]){
            printf("%d\n", sum + 2);
        }
    }else if(avail[2]){
        int sum = n / 2;
        int rest = n % 2;
        if(rest == 0){
            printf("%d\n", sum);
        }else if(avail[1]){
            printf("%d\n", sum + 1);
        }else{
            printf("-1\n");
        }
    }else if(avail[1]){
        printf("%d\n", n);
    }else{
        printf("-1\n");
    }
    return 0;
}
