#include <bits/stdc++.h>

using namespace std;

bool canJump1(string s, int m)
{
    if(m==1) return true;
    if(s[0]!=s[1]) return true;
    if(s[m-1]!=s[m-2]) return true;
    for(int i=1; i<=(m-2); i++)
    {
        if(s[i]!=s[i-1] && s[i]!=s[i+1]) return true;
    }
    return false;
}

bool canJump2(string s, int m)
{
    if(m<2) return false;
    if(m==2)
    {
        if(s[0]==s[1]) return true;
        return false;
    }
    if(s[0]==s[1] && s[1]!=s[2]) return true;
    if(s[m-1]==s[m-2] && s[m-2]!=s[m-3]) return true;
    for(int i=1; i<=(m-2); i++)
    {
        if(s[i]==s[i+1] && s[i-1]!=s[i] && s[i+2]!=s[i+1]) return true;
    }
    return false;
}

bool canJump3(string s, int m)
{
    if(m<3) return false;
    if(m==3)
    {
        if(s[0]==s[1] && s[1]==s[2]) return true;
        return false;
    }
    if(s[0]==s[1] && s[1]==s[2] && s[2]!=s[3]) return true;
    if(s[m-1]==s[m-2] && s[m-2]==s[m-3] && s[m-3]!=s[m-4]) return true;
    for(int i=1; i<=(m-4); i++)
    {
        if(s[i]==s[i+1] && s[i+1]==s[i+2] && s[i-1]!=s[i] && s[i+3]!=s[i]) return true;
    }
    return false;
}

int solve(int n, bool one, bool two, bool three)
{
    int step1=0,step2=0,step3=0;
    if(one && two && three)
    {
        if(n%3!=0) return (n/3+1);
        return n/3;
    }
    if(one && two && !three)
    {
        if(n%2!=0) return (n/2+1);
        return n/2;
    }
    if(one && !two && three)
    {
        if(n%3==0) return n/3;
        if(n%3==1) return n/3+1;
        return n/3+2;
    }
    if(one && !two && !three)
    {
        return n;
    }
    if(!one && two && three)
    {
        if(n%3==0) return n/3;
        if(n%3==2) return n/3+1;
        return (n/3-1)+2;
    }
    if(!one && two && !three)
    {
        if(n%2==0) return n/2;
        return -1;
    }
    if(!one && !two && three)
    {
        if(n%3==0) return n/3;
        return -1;
    }
    return -1;
}

int main()
{
    freopen("game.in","r", stdin);
    freopen("game.out","w",stdout);
    int n,m;
    bool one,two,three;
    string s;
    cin >> n >> m;
    cin >> s;
    one=canJump1(s,m);
    two=canJump2(s,m);
    three=canJump3(s,m);
    cout << solve(n,one,two,three) << '\n';
    return 0;
}
