/* GCC */
#include <fstream>
#include <limits>
#include <vector>
#include <algorithm>
int main() {
    std::ifstream input("passat.in");
    std::ofstream output("passat.out");

    int n;
    input >> n;

    int t = std::numeric_limits<int>::max();

    std::vector<std::pair<int, int> > data(n);
    for(int i = 0; i < n; ++i) {
        input >> data[i].second >> data[i].first;
    }

    std::sort(data.begin(), data.end(), std::greater<std::pair<int, int> >());
    int workable = data[0].second;
    for(int i = 1; i < n; ++i) {
        if((data[i - 1].first - data[i].first) >= workable) {
            workable = 0;
        } else {
            workable -= data[i - 1].first - data[i].first;
        }
        workable += data[i].second;
    }

    output << data[n - 1].first - workable << "\n";

    return 0;
}
