#include <bits/stdc++.h>

using namespace std;

bool prime_number(long long a) {
    int i = 3;
    if (a < 2)
        return 0;
    if (a == 2)
        return 1;
    if (a % 2 == 0)
        return 0;
    while (i <= sqrt(a)) {
        if (a % i == 0)
            return 0;
        i += 2;
    }
    return 1;
}

long long NOD (long long a, long long b) {
    if (a < b)
        swap(a, b);
    while(b != 0) {
        a %= b;
        swap(a, b);
    }
    return a;
}

long long NSK (long long a, long long b) {
    return a / NOD(a, b) * b;
}



int main()
{
    freopen("equation.in", "r", stdin);
    freopen("equation.out", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    long long a, b, c, d;
    cin >> a >> b >> c >> d;
    if (pow(a, 3) + b * b + c == d) {
        cout << a << " " << b << " " << c << "\n";
        return 0;
    }
    if (pow(a, 3) + c * c + b == d) {
        cout << a << " " << c << " " << b << "\n";
        return 0;
    }
    if (pow(b, 3) + a * a + c == d) {
        cout << b << " " << a << " " << c << "\n";
        return 0;
    }
    if (pow(b, 3) + c * c + a == d) {
        cout << b << " " << c << " " << a << "\n";
        return 0;
    }
    if (pow(c, 3) + a * a + b == d) {
        cout << c << " " << a << " " << b << "\n";
        return 0;
    }
    if (pow(c, 3) + b * b + a == d) {
        cout << c << " " << b << " " << a << "\n";
        return 0;
    }
    cout << "-1 -1 -1\n";
    return 0;
}
