#include <bits/stdc++.h>

using namespace std;

bool prime_number(long long a) {
    int i = 3;
    if (a < 2)
        return 0;
    if (a == 2)
        return 1;
    if (a % 2 == 0)
        return 0;
    while (i <= sqrt(a)) {
        if (a % i == 0)
            return 0;
        i += 2;
    }
    return 1;
}

long long NOD (long long a, long long b) {
    if (a < b)
        swap(a, b);
    while(b != 0) {
        a %= b;
        swap(a, b);
    }
    return a;
}

long long NSK (long long a, long long b) {
    return a / NOD(a, b) * b;
}

struct step{
    char step;
    bool can = false;
};

int main()
{
    freopen("game.in", "r", stdin);
    freopen("game.out", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m, cnt_s = 1;
    string s;
    step step_1, step_2, step_3;
    step_1.step = 1;
    step_2.step = 2;
    step_3.step = 3;
    cin >> n >> m >> s;
    for (int i = 1; i < m; i++) {
        if (s[i] == s[i - 1])
            cnt_s++;
        else {
            if (cnt_s == 1)
                step_1.can = true;
            if (cnt_s == 2)
                step_2.can = true;
            if (cnt_s == 3)
                step_3.can = true;
            cnt_s = 1;
        }
    }
    if (cnt_s == 1)
        step_1.can = true;
    if (cnt_s == 2)
        step_2.can = true;
    if (cnt_s == 3)
        step_3.can = true;

    if (step_3.can) {
        if (n % 3 == 0) {
            cout << n / 3 << "\n";
            return 0;
        }
        if (step_2.can && n % 3 == 2) {
                cout << n / 3 + 1 << "\n";
                return 0;
            }
        if (step_1.can && n % 3 == 1) {
            cout << n / 3 + 1 << "\n";
            return 0;
        }
        if (step_2.can && n % 3 == 1) {
                cout << n / 3 + 1 << "\n";
                return 0;
        }
        if (step_1.can && n % 3 == 2) {
                cout << n / 3 + 2 << "\n";
                return 0;
        }
        cout << "-1\n";
    }
    if (step_2.can){
        if (n % 2 == 0) {
            cout << n / 2 << "\n";
            return 0;
        }
        if (step_1.can) {
            cout << n / 2 + 1 << "\n";
            return 0;
        }
        cout << "-1\n";
        return 0;
    }
    if (step_1.can) {
        cout << n << "\n";
        return 0;
    }
    cout << "-1\n";
    return 0;
}
