#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <climits>

#define MAX 200000 + 1
#define ll long long

using namespace std;

pair<int, int> req[MAX];

bool pair_comp(pair<int, int> a, pair<int, int> b){
    return a.second > b.second || (a.second == b.second && a.first > b.first);
}

int main()
{
    int n;
    freopen("passat.in", "r", stdin);
    freopen("passat.out", "w", stdout);
    scanf("%d", &n);
    for(int i = 0; i < n; i++){
        scanf("%d%d", &req[i].first, &req[i].second);
    }
    sort(req, req + n, pair_comp);
    int cur_max = req[0].second;
    for(int i = 0; i < n; i++){
        if(req[i].second < cur_max)
            cur_max = req[i].second;
        cur_max -= req[i].first;
    }
    printf("%d\n", cur_max);
    return 0;
}
