#include <bits/stdc++.h>

using namespace std;

#define int long long

struct Rekl{
    int t, d;
    Rekl(){}
    Rekl(int t, int d){
        this->t = t;
        this->d = d;
    }
};

bool operator<(const Rekl& a, const Rekl& b){
    if (a.d == b.d){
        return a.t > b.t;
    }
    return a.d < b.d;
}

vector<Rekl> r;

bool check(const int& m){
    int day = m, n = (int)r.size();
    for (int i = 0; i < n; i++){
        if (day+r[i].t > r[i].d){
            return false;
        }
        day += r[i].t;
    }
    return true;
}

signed main(){
    ios_base::sync_with_stdio(false);
    freopen("passat.in", "r", stdin);
    freopen("passat.out", "w", stdout);
    int n;
    cin >> n;
    r.resize(n);
    for (int i = 0; i < n; i++){
        cin >> r[i].t >> r[i].d;
    }
    sort(r.begin(), r.end());
    int mind = r[0].d;
    int l = 0, r = mind+1;
    while (l+1 < r){
        int m = (l+r)/2;
        if (check(m)){
            l = m;
        } else {
            r = m;
        }
    }
    cout << l << endl;
    return 0;
}




































