/*GCC*/
#include <iostream>
#include <vector>
#include <algorithm>
#include <fstream>
using namespace std;
struct Adv {
    int days;
    int deadline;
};
struct Compare {
    bool operator() (const Adv& adv1, const Adv& adv2) {
        return adv1.deadline < adv2.deadline;
    }
};
int main()
{
    ifstream fin("passat.in");
    ofstream fout("passat.out");
    int n;
    vector<Adv> arr;
    fin >> n;
    Adv adv;
    for(int i = 0; i < n; i++) {
        fin >> adv.days;
        fin >> adv.deadline;
        arr.push_back(adv);
    }
    sort(arr.begin(), arr.end(), Compare());
    int ans = arr[0].deadline - arr[0].days;
    int counter = arr[0].deadline;
    for(int i = 1; i < arr.size(); i++) {
        counter = counter + arr[i].days;
        if(counter > arr[i].deadline) {
            ans += arr[i].deadline - counter;
            counter = arr[i].deadline;
        }
    }
    fout << ans << endl;
    fin.close();
    fout.close();
    return 0;
}
