#include <fstream>
using namespace std;

ifstream cin("passat.in");
ofstream cout("passat.out");

//DATA
int amount;
int *end_date;
int *real_date;
int *days;

//SWAP
void swp(int &a, int &b){
    int buffer = a;
    a = b;
    b = buffer;
}

//MERGE SORT
int *temp;
int *temp2;

void merg(int l, int r){
    if(r-l<=1){
        if(end_date[r]<end_date[l]){swp(end_date[r],end_date[l]);swp(days[r],days[l]);}
        return;
    }
    int c = (l+r)/2;
    merg(l, c);
    merg(c+1, r);
    int l_counter = l;
    int r_counter = c+1;
    int temp_counter = 0;
    while(l_counter<=c || r_counter<=r){
        if((end_date[l_counter]<end_date[r_counter] || r_counter>r) && l_counter<=c){
            temp[temp_counter] = end_date[l_counter];
            temp2[temp_counter] =  days[l_counter];
            l_counter++;
            temp_counter++;
        }
        else /*if(end_date[r_counter]<end_date[l_counter] || l_counter>c)*/{
            temp[temp_counter] = end_date[r_counter];
            temp2[temp_counter] = days[r_counter];
            r_counter++;
            temp_counter++;
        }
    }


    for(int i=0; i<temp_counter; i++){
        end_date[l+i]=temp[i];
        days[l+i]=temp2[i];
    }
}

int main(){
    cin >> amount;
    days = new int[amount];
    end_date = new int[amount];
    real_date = new int[amount];
    temp = new int[amount];
    temp2 = new int[amount];
    for(int i=0; i<amount; i++){cin >> days[i]; cin >> end_date[i];}

    merg(0, amount-1);
    real_date[0]=days[0];
    for(int i=1; i<amount; i++)real_date[i]=real_date[i-1]+days[i];
    int minimum = 2000000000;
    for(int i=0; i<amount; i++)if(end_date[i]-real_date[i]<minimum)minimum = end_date[i]-real_date[i];
    cout << minimum;
    return 0;
}
