#include <iostream>
#include <bits/stdc++.h>

unsigned long m;

inline bool f(char *s, long i, long j) {
    long k;
    bool b1, b2;
    for (k = i; k <= i+j; ++k) {
        b1 = b2 = false;
        if (i) if (s[k] == s[i-1]) b1 = true;
        if (i + j + 1 < m) if (s[k] == s[i+j+1]) b2 = true;
        if (b1 || b2 || (s[i] != s[k])) return false;
    }
    return true;
}

using namespace std;
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	freopen("game.in", "r", stdin);
	freopen("game.out", "w", stdout);
	long n, i, j;
	long int answ = 0;
	bool a[3] = {0};
	cin >> n >> m;
	char s[m];
	for (i = 0; i < m; ++i) cin >> s[i];
	for (i = 0; i < m; ++i)
        for (j = 0; j < 3 && i + j < m; ++j)
            if (!a[j]) a[j] = f(s, i, j);
            //a[j] = f(s, i, j);
    for (i = 3; i >= 1; --i)
        if (a[i-1] && n) {
            answ += n/i;
            n %= i;
            if (i == 3 && n == 1 && !a[0] && a[1]) {
                --answ;
                n += 3;
            }
        }
    if (!n) cout << answ << '\n';
    else cout << "-1\n";
	return 0;
}





/*


III етап Всеукраїнської олiмпiади з iнформатики 2019-2020 - II тур
Загальна iнформацiя
Загальне
• Вам дано 5 годин на розв’язання 5 задач, кожна з яких оцiнюється в 100 балiв.
• Ви можете зробити до 60 вiдправок. Немає значення, як саме ви використаєте цi вiдправлення
по задачах. Ви можете вiдправити будь-яку кiлькiсть рiшень на кожну задачу, але сумарна
кiлькiсть вiдправлень по всiм задачам не має перевищувати 60.
• Обмеження на час та пам’ять знаходяться у системi тестування.
• Обмеження на час для Java та Python можуть бути бiльшими.
• Журi не гарантує, що iснують розв’язки на повний бал на таких мовах, як Pascal, Python та
Java.
• Пiд час олiмпiади суворо забороняється використовувати iнтернет, за виключенням сайту, на
якому ви працюєте. Не можна використовувати будь-якi переноснi носiї iнформацiї.
• Результати олiмпiади будуть доступнi на сайтi https://oi.in.ua/ пiсля змагання.
• Просимо залишити ваш вiдгук про олiмпiаду пiсля завершення тура за посиланням
http://bit.ly/uoi-obl-feedback
Оцiнювання
Є два види оцiнювання:
• «Потестове оцiнювання». Кожний тест оцiнюється незалежно вiд iнших. Проходження тесту
приносить певну кiлькiсть балiв. Приклади оцiнюються в 0 балiв.
• «Блочне оцiнювання». Усi тести подiленi на блоки, якi описанi в умовi задачi. Бали нараховуються лише при проходженнi всiх тестiв блоку. Якщо обмеження блока i не меншi за
обмеження блока j, то для нарахування балiв за блок i, також потрiбно, щоб пройшли всi
тести блока j. В умовi про це не буде сказано. Також є «нульовий блок», який складається
з прикладiв, вiн оцiнюється в 0 балiв. В умовi про це згадувати не будуть. Звернiть увагу,
що такi задачi можуть мiстити змiнну g — номер блока. Якщо вона вам непотрiбна, то вам
непотрiбно її використовувати.
Питання
Ви можете ставити питання виключно через систему тестування протягом усього часу олiмпiади.
Сторiнка 1 з 8
III етап Всеукраїнської олiмпiади з iнформатики 2019-2020 - II тур
Задача A. Себек та рiвняння
Назва вхiдного файлу: equation.in
Назва вихiдного файлу: equation.out
У Себека є три цiлi числа x, y та z. Себек хоче пiднести якесь з цих чисел до третього степеня,
ще одне пiднести до другого, а iнше залишити незмiнним, таким чином, щоб їх сума дорiвнювала k.
Iншими словами, формула матиме такий вигляд:
a
3 + b
2 + c = k
Ваше завдання визначити, яке з даних чисел x, y та z Себеку доведеться пiднести до третього
степеня, яке до другого степеня, а яке залишити незмiнним так, щоб їх сума дорiвнювала k.
Якщо iснує декiлька способiв вибрати такi числа, то виведiть будь-який.
Зауважте, що обов’язково має бути рiвно одне число, пiднесене до третього степеня та рiвно
одне число, пiднесене до другого степеня, та рiвно одне, яке залишиться незмiнним.
Формат вхiдних даних
Перший рядок мiстить чотири цiлi числа x, y, z та k (1 6 x, y, z 6 103
, 1 6 k 6 109
) — три числа,
що данi Себеку, та бажана їхня сума пiсля пiднесення одного з них до третього степеня i ще одного
до другого степеня.
Формат вихiдних даних
У єдиному рядку виведiть три цiлi числа a, b, c — число, яке буде пiднесене до третього степеня,
число, яке буде пiднесене до другого степеня, та число, яке залишиться незмiнним. Якщо неможливо
вибрати такi a, b, c з даних в умовi трьох чисел так, що a
3 + b
2 + c = k, то виведiть «−1 − 1 − 1»
(без лапок).
Якщо правильних вiдповiдей декiлька, виведiть будь-яку.
Приклади
equation.in equation.out
4 1 9 26 1 4 9
1 2 3 100 -1 -1 -1
Примiтка
У першому прикладi 1
3 + 42 + 9 = 1 + 16 + 9 + 26.
У другому прикладi вiдповiдi немає.
Сторiнка 2 з 8
III етап Всеукраїнської олiмпiади з iнформатики 2019-2020 - II тур
Задача B. Себек i сусiди
Назва вхiдного файлу: neighbors.in
Назва вихiдного файлу: neighbors.out
Себека дуже не люблять сусiди. Тому вони вирiшили зробити йому пастку.
Сусiди намалювали на асфальтi таблицю, що складається з n рядкiв i n стовпцiв. Рядки пронумерованi вiд 1 до n зверху вниз, а стовпцi вiд 1 до n злiва направо. Таким чином таблиця складається
з n рядкiв, у кожному з яких n клiтинок. Вони пронумерували клiтинки таблицi таким чином, що
клiтинки першого рядка мають номери вiд 1 до n злiва направо, другого рядка — номери вiд n + 1
до 2n теж злiва направо i так далi. На малюнку знизу показано приклад таблицi для n = 4.
Приклад для n = 4.
Злi сусiди пустили Себека бiгати по таблицi та iнодi його зупиняли. Коли вiн зупиняється, вiн
повинен подивитися на число в тiй клiтинцi таблицi, в якiй вiн знаходиться, i вiдповiсти на два
питання:
1. Чи вiн знаходиться на головнiй дiагоналi таблицi?
2. Чи вiн знаходиться на другоряднiй дiагоналi?
Нагадаємо, що головна дiагональ — це дiагональ, на якiй знаходяться клiтинки, що лежать
мiж верхньою лiвою i нижньою правою клiтинками, вони позначенi жовтим кольором на малюнку.
Зауважте, що фiгура — квадрат.
А другорядна дiагональ — це дiагональ, на якiй знаходяться клiтинки, що лежать мiж верхньою
правою i нижньою лiвою клiтинками, вони позначенi блакитним кольором на малюнку.
Уявiть, що ви Себек i вам треба вiдповiдати на цi питання.
Формат вхiдних даних
Перший рядок мiстить два цiлих числа n та m (1 6 n 6 100, 1 6 m 6 n · n) — розмiр таблицi та
номер клiтинки, у якiй знаходиться Себек пiд час чергової зупинки сусiдами.
Формат вихiдних даних
Виведiть два слова, роздiлених пробiлом.
Перше слово повинно бути «yes», якщо Себек знаходиться на головнiй дiагоналi, i «no», якщо
не знаходиться.
Друге слово повинно бути «yes», якщо Себек знаходиться на другоряднiй дiагоналi, i «no», якщо
не знаходиться.
Зауважте, що ви можете виводити лiтери у будь-якому регiстрi. Тобто ви можете виводити як
великi лiтери, так i маленькi.
Приклади
neighbors.in neighbors.out
4 16 yes no
4 2 no no
4 10 no yes
Сторiнка 3 з 8
III етап Всеукраїнської олiмпiади з iнформатики 2019-2020 - II тур
Задача C. Ух i сусiди
Назва вхiдного файлу: game.in
Назва вихiдного файлу: game.out
Сусiди знову котять бочку на Себека i придумують йому новi випробування. Цього разу у них є
вiдрiзок довжиною n. Сусiди помiстили Себека в точку з координатою 0 i сказали йому прострибати
до точки з координатою n.
Але у Себека є проблема. Вiн може стрибати лише вперед на довжину 1, 2 або 3. Проте сусiди
вирiшили ще бiльше його обмежити. Вони дали йому рядок s довжиною m, що складається з малих
латинських лiтер. Себек може стрибати вперед на довжину x (1 6 x 6 3), якщо у рядку s є пiдрядок,
для якого виконуються наступнi умови:
1. Пiдрядок має довжину x.
2. Усi лiтери однаковi.
3. Злiва вiд пiдрядка знаходиться буква, якої немає у пiдрядку, або такої букви немає взагалi
(пiдрядок знаходиться скраю).
4. Справа вiд пiдрядка знаходиться буква, якої немає у пiдрядку, або такої букви немає взагалi.
Рядок a називається пiдрядком b, якщо можна отримати a з b, видаляючи кiлька (можливо,
жодного або всi) символiв з початку i кiлька (можливо, жодного або всi) символiв з кiнця.
Наприклад, нехай є рядок «aabaaabbcbbbebbab» та x = 2. Тодi у рядку є кiлька пiдрядкiв,
якi пiдходять пiд обмеження: «(aa)baaa(bb)cbbbe(bb)ab». Тому у цьому випадку можна стрибати
на довжину 2. Крiм цього, цей рядок дозволяє стрибати також i на довжини 1 i 3. А от рядок
«ebbbcedddd» дозволяє стрибати лише на довжини 1 i 3.
Себеку треба, стрибаючи тiльки на дозволену довжину вперед, з точки 0 потрапити у точку з
координатою n за мiнiмальну кiлькiсть стрибкiв. Уявiть, що ви Себек, i порахуйте цю мiнiмальну
кiлькiсть стрибкiв.
Звернiть увагу, що Себеку потрiбно потрапити саме у точку з координатою n, а не n+ 1 чи n+ 2.
Формат вхiдних даних
Перший рядок мiстить одне цiле число n (1 6 n 6 1 000 000 000) — довжина вiдрiзка, по якiй
стрибає Себек.
Другий рядок мiстить одне цiле число m (1 6 m 6 200 000) — довжина рядка сусiдiв.
Третiй рядок мiстить рядок s довжиною m, що складається з малих латинських лiтер — рядок
сусiдiв.
Формат вихiдних даних
Виведiть одне цiле число — мiнiмальну кiлькiсть стрибкiв, що потрiбно зробити Себеку, щоб
потрапити в точку з координатою n, починаючи з точки з координатою 0. Якщо вiн це зробити не
може, то виведiть −1.
Приклади
game.in game.out
4
5
acccz
2
11
18
bbbccccdddbcggggga
5
10
5
zzzzz
-1
Сторiнка 4 з 8
III етап Всеукраїнської олiмпiади з iнформатики 2019-2020 - II тур
Примiтка
1. Себек може стрибати на 1 i 3. Можливий варiант стрибкiв 1 + 3 = 4
2. Себек може стрибати на 1 i 3. Можливий варiант стрибкiв 1 + 3 + 3 + 1 + 3 = 11
3. Себек не може стрибати взагалi, бо єдиний пiдрядок з однакових лiтер має довжину 5.
Сторiнка 5 з 8
III етап Всеукраїнської олiмпiади з iнформатики 2019-2020 - II тур
Задача D. Iлля ремонтує Пассат
Назва вхiдного файлу: passat.in
Назва вихiдного файлу: passat.out
Iлля, головний менеджер по рекламi Сергiя, дуже любить свiй автомобiль — Volkswagen Passat
2008 року випуску (Пассат). Але вiн дуже часто ламається, та ось знову зламався двигун.
Щоб полагодити Пассат, Iлля повинен заробити грошей. Оскiльки вiн є менеджером по рекламi
Сергiя, вiн може планувати розмiщення реклами в iнстаграмi Сергiя та отримувати з цього процент. В один день в iнстаграмi можна розмiстити тiльки одну рекламу. В Iллi вже є n замовлень
на рекламу, кожне з яких характеризується двома цiлими числами: ti — кiлькiсть днiв, коли треба
розмiщувати рекламу з цього замовлення, та di — день, до якого треба встигнути розмiстити цю рекламу ti разiв. Iлля не зобов’язаний показувати всю рекламу для одного рекламодавця в послiдовнi
днi.
Iлля хоче спланувати розмiщення реклами в iнстаграмi так, щоб задовольнити кожного рекламодавця, тобто розмiсти кожну рекламу стiльки разiв, скiльки потрiбно i встигнути до останнього дня
включно. Але Iлля дуже ледачий, тому хоче першi декiлька днiв взагалi нiчого не робити, а тiльки
потiм почати розмiщення реклами. Допоможiть йому i скажiть, скiльки максимально днiв Iлля може нiчого не робити в початку, а тiльки потiм почати розмiщення реклами, при цьому задовольнити
всiх рекламодавцiв.
Формат вхiдних даних
Перший рядок мiстить одне цiле число n (1 6 n 6 2 · 105
) — кiлькiсть замовлень на рекламу.
Кожен з наступних n рядкiв мiстить по два цiлi числа ti та di (1 6 ti
, di 6 109
) — кiлькiсть днiв,
скiльки потрiбно розмiщувати i-ту рекламу, та останнiй можливий день розмiщення цiєї реклами.
Формат вихiдних даних
Виведiть одне цiле число — вiдповiдь на завдання.
Приклади
passat.in passat.out
4
1 3
1 10
50 100
9 13
2
10
1 91
5 96
5 62
3 67
5 57
1 93
4 67
4 23
1 53
1 76
19
Примiтка
У першому прикладi є чотири замовлення на рекламу. Iлля може спочатку 2 днi нiчого не робити,
а потiм на 3-iй день виконати перше замовлення в останнiй можливий день. Далi є вибiр. Або вiдразу
виконати друге замовлення за 4-ий день, а потiм 9 днiв пiдряд вiд 5-го до 13-го розмiщувати четверту
рекламу. Або можна, наприклад, вiд 4-го до 9-го дня виконувати четверте замовлення, пiсля чого 10-
го дня виконати друге замовлення, i далi до 13-го дня продовжити виконувати четверте замовлення.
Пiсля цього вiд 14-го до 100-го дня вiн може розмiщувати третю рекламу в будь-якi 50 днiв.
Сторiнка 6 з 8
III етап Всеукраїнської олiмпiади з iнформатики 2019-2020 - II тур
Задача E. Себек мстить сусiдам
Назва вхiдного файлу: sebek.in
Назва вихiдного файлу: sebek.out
Ох i навитворяли тi сусiди. Так сильно ненавидiли Себека, робили йому рiзнi пастки i неприємностi. I ось, нарештi, Себеку наснився сон. Не простий, а той, в якому вiн може вигнати всiх сусiдiв
з дому.
Дiм Себека має форму кола, подiленого на квартири. Всього в будинку n квартир, пронумерованих вiд 1 до n за годинниковою стрiлкою. Наступною пiсля квартири з номером 1 6 i 6 n − 1
знаходиться квартира з номером i + 1, а пiсля квартири n знаходиться квартира 1. У квартирi з
номером i живе ai сусiдiв.
Щоб виганяти мешканцiв з дому Себек може k разiв запустити жабу в якусь з квартир. Потужнiсть всiх жаб — цiле число вiд 0 до 4 i дорiвнює m для всiх жаб. Себек не обов’язково кожен раз
запускає жаб в одну й ту ж саму квартиру. Коли Себек запускає жабу в квартиру з номером i, то
тi сусiди, що в цей момент часу знаходяться у квартирi i тiкають з дому назавжди. Також сусiди з
m наступних квартир за годинниковою стрiлкою лякаються i переселяються у m + 1-шу наступну
квартиру за годинниковою стрiлкою. Так само i проти годинникової стрiлки. Сусiди з m попереднiх
квартир проти годинникової стрiлки лякаються i переселяються у m + 1-шу попередню квартиру
проти годинникової стрiлки.
Тобто, якщо в будинку 7 квартир i жаба полетiла у квартиру з номером 6, а m = 1, то з шостої квартирi всi зникнуть назавжди, з сьомої квартири мешканцi переселяться в першу, а з п’ятої
квартири переселяться в четверту. Якщо m = 0, то нiхто нiкуди не переселяється, просто сусiди з
квартири i тiкають.
Внизу зображено три рисунки для n = 8 i m = 2. На першому зображено початкову кiлькiсть
сусiдiв в кожнiй квартирi. На другому — кiлькiсть сусiдiв пiсля того, як жаба полетiла в квартиру
5. На третьому зображено розселення пiсля того, як ще одна жаба полетiла в квартиру 2. Навколо
будинку написанi номери квартир. Жовтим кольором видiлено квартиру в яку летить жаба.
Звичайно, Себек хоче вигнати з дому якнайбiльше сусiдiв. Але вiн ще недостатньо розумний,
тому просить вас допомогти йому i сказати максимальну кiлькiсть сусiдiв, яку можна вигнати з
дому за k запускiв жаб.
Формат вхiдних даних
Перший рядок мiстить три цiлi числа n, k та m (0 6 m 6 4, 2 · m + 3 6 n 6 2 000, 1 6 k 6 n) —
кiлькiсть квартир у будинку, кiлькiсть запускiв жаб та потужнiсть жаб вiдповiдно.
Другий рядок мiстить n цiлих чисел ai (0 6 ai 6 1 000 000) — кiлькiсть мешканцiв у квартирах.
Третiй рядок мiстить одне цiле число g (0 6 g 6 10) — номер блоку, до якого належить тест.
Формат вихiдних даних
В єдиному рядку виведiть одне цiле число — максимальну кiлькiсть сусiдiв, яку може вигнати
Себек.
Сторiнка 7 з 8
III етап Всеукраїнської олiмпiади з iнформатики 2019-2020 - II тур
Приклади
sebek.in sebek.out
8 2 2
10 10 6 7 15 8 2 1
0
38
5 2 1
2 4 2 1 7
0
13
Оцiнювання
1. (10 балiв) m 6 0.
2. (10 балiв) n 6 11.
3. (10 балiв) m 6 1, при цьому в перших m квартирах i в останнiх m квартирах нiхто не живе.
4. (10 балiв) m 6 2, при цьому в перших m квартирах i в останнiх m квартирах нiхто не живе.
5. (10 балiв) m 6 1, при цьому усi квартири пустi або iснують такi m + 1 6 l 6 r 6 n − m, що на
вiдрiзку квартир вiд l до r живуть по одному сусiду, а у всiх iнших квартирах нiхто не живе.
6. (10 балiв) m 6 1, при цьому або виконуються умови блоку 5, або iснують такi m+ 1 6 l1 6 r1 <
< l2 6 r2 6 n− m, що на вiдрiзках квартир вiд l1 до r1 та вiд l2 до r2 живуть по одному сусiду,
у всiх iнших квартирах нiхто не живе, i m + 1 6 l2 − r1.
7. (10 балiв) m 6 1.
8. (10 балiв) m 6 2.
9. (10 балiв) m 6 3.
10. (10 балiв) Без додаткових обмежень.
Сторiнка 8 з 8


*/

