#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define int ll
typedef long double ld;

typedef pair<int,int> pii;
#define x first
#define y second

const int N=2010;

int a[N],b[N];

pii solve5(int l,int r,int k)
{
    if(k<=0)
        return {0,0};
    return {min(r-l+1,1+2*(k-1)),(r-l+1)/2+1};
}

int solve6(int l1,int r1,int l2,int r2,int k)
{
    int ans=0;
    ans=max(ans,solve5(l1,r1,k).x+solve5(l2,r2,k-solve5(l1,r1,k).y).x);
    ans=max(ans,solve5(l2,r2,k).x+solve5(l1,r1,k-solve5(l2,r2,k).y).x);
    if((r1-l1+1)%2==0)
        ans=max(ans,solve5(l1,r1,k).x-1+solve5(l2,r2,k-solve5(l1,r1,k).y+1).x);
    if((r2-l2+1)%2==0)
        ans=max(ans,solve5(l2,r2,k).x-1+solve5(l1,r1,k-solve5(l2,r2,k).y+1).x);
    if(r1+2!=l2)
        return ans;
    int res=solve5(l1,r2,k).x;
    if(res>r1-l1+1&&res>r2-l2+1)
        res--;
    return max(ans,res);
}

int solve2(vector<int> a,int k,int m,int pos=-1)
{
    if(k<=0)
        return 0;
    int n=a.size();
    if(pos!=-1)
    {
        vector<int> b=a;
        for(int i=pos-m;i<=pos+m;i++)
            b[(i+2*n)%n]=0;
        for(int i=pos-m;i<=pos-1;i++)
            b[(pos-m-1+2*n)%n]+=a[(i+2*n)%n];
        for(int i=pos+1;i<=pos+m;i++)
            b[(pos+m+1+2*n)%n]+=a[(i+2*n)%n];
        a=b;
    }
    int ans=0;
    for(int i=0;i<n;i++)
        if(a[i])
            ans=max(ans,a[i]+solve2(a,k-1,m,i));
    return ans;
}

int dp[N][N][2];

int sum(int l,int r,int n)
{
    int ans=0;
    if(l<=r)
        for(int i=l;i<=r;i++)
            ans+=a[i];
    else
    {
        for(int i=l;i<=n;i++)
            ans+=a[i];
        for(int i=1;i<=r;i++)
            ans+=a[i];
    }
    return ans;
}

signed main()
{
    #ifndef LOCAL
        #define name "sebek"
        freopen(name".in","r",stdin);
        freopen(name".out","w",stdout);
        ios_base::sync_with_stdio(0);
        cin.tie(0);
        cout.tie(0);
        #undef name
    #endif // LOCAL

    int n,k,m;
    cin>>n>>k>>m;
    for(int i=1;i<=n;i++)
        cin>>a[i];
    int g;
    cin>>g;
    if(m==0)
    {
        sort(a+1,a+n+1,greater<int>());
        cout<<accumulate(a+1,a+k+1,0ll);
        exit(0);
    }
    if(k==0)
    {
        cout<<0;
        exit(0);
    }
    int l=n+1,r=0;
    for(int i=1;i<=n;i++)
        if(a[i])
            l=min(l,i),
            r=max(r,i);
    if(!r)
        cout<<0,exit(0);
    int l0=n+1,r0=0;
    for(int i=l;i<=r;i++)
        if(!a[i])
            l0=min(l0,i),
            r0=max(r0,i);
    if(g==5||g==6&&!r0)
    {
        cout<<solve5(l,r,k).x;
        exit(0);
    }
    if(g==6)
    {
        int l1=l,r1=l0-1,l2=r0+1,r2=r;
        cout<<solve6(l1,r1,l2,r2,k);
        exit(0);
    }
    if(n<=11)
    {
        cout<<solve2(vector<int>(a+1,a+n+1),k,m);
        exit(0);
    }
//    if(g==3||g==4)
//    {
//        int ans=0;
//        for(int i=m+1;i<=n;i++)
//            for(int j=1;j<=k;j++)
//            {
//                dp[i][j][0]=max(dp[i-1][j][0],a[i]+dp[i-m-1][j-1][1]);
//                dp[i][j][1]=max(dp[i-1][j][0],sum(i,i+m,n)+dp[i-m-1][j-1][1]);
//                ans=max(ans,dp[i][j][0]);
//            }
//        cout<<ans;
//        exit(0);
//    }
    if(g==3||g==4||g>=7)
    {
        #define norm(x) (((x)+n-1)%n+1)
        int ans=0;
        while(clock()*1.0/CLOCKS_PER_SEC<0.95)
        {
            int pos=rand()%n+1;
            for(int i=1;i<=n;i++)
                b[i]=a[i];
            for(int i=pos-m;i<=pos+m;i++)
                b[norm(i)]=0;
            for(int i=pos-m;i<=pos-1;i++)
                b[norm(pos-m-1)]+=a[norm(i)];
            for(int i=pos+1;i<=pos+m;i++)
                b[norm(pos+m+1)]+=a[norm(i)];
            memset(dp,0,sizeof(dp));
            for(int i=pos+m+1;i<=pos-m-1+n;i++)
                for(int j=1;j<=k;j++)
                {
                    dp[norm(i)][j][0]=max(dp[norm(i-1)][j][0],a[norm(i)]+dp[norm(i-m-1)][j-1][1]);
                    dp[norm(i)][j][1]=max(dp[norm(i-1)][j][0],sum(norm(i),norm(i+m),n)+dp[norm(i-m-1)][j-1][1]);
                    ans=max(ans,dp[norm(i)][j][0]);
                }
        }
        cout<<ans;
        exit(0);
    }
}
